/****************************************************************************
 *	Copylight(C) 2011 Kanazawa-soft-design,LLC.All Rights Reserved.
 ****************************************************************************/
/*!
 *	@file	sample_0004.cpp
 *
 *	@brief	ASIO𗘗pTEho̓vO.
 *
 *	@author	V 閾
 */
#include <windows.h>
#include <windowsX.h>
#include <stdio.h>
#include <commctrl.h>
#include <tchar.h>
#include <math.h>
#include "resource.h"
#include "WaveFile.h"
#include "ginclude.h"
#include "asio.h"
#include "asiodrivers.h"

// ֐vg^Cv.
static LRESULT CALLBACK	SoundOutProc( HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam );
static void				OnInitDialog( HWND hDlg );
static BOOL				OnSelectFile( HWND hDlg );
static BOOL				PlaySoundOutput( HWND hDlg );
static void				PauseSoundOutput( HWND hDlg );
static void				StopSoundOutput( HWND hDlg );
static BOOL				OpenSoundOutDevice( HWND hDlg, UINT num, WAVEFORMATEX* wf );
static void				CloseSoundOutputDevice( void );
static void				bufferSwitch( long index, ASIOBool processNow );

// Oϐ.
extern AsioDrivers*		asioDrivers;				//!< ASIOhCõIuWFNg.

// [Jϐ.
static HWND				AppWnd;						//!< AvP[ṼEChEnh.
static ASIOBufferInfo	BufInfo[16];				//!< e`l̃obt@e[u.
static BYTE*			DataBuff;					//!< f[^obt@.
static DWORD			DataSize;					//!< f[^TCY.
static DWORD			DevCnt;						//!< ASIOfoCX̌.
static char				DevName[10][32];			//!< ASIOfoCX̖Oe[u.
static TCHAR			FileName[MAX_PATH+1];		//!< ĐWAVt@C̃t@C.
static DWORD			BufSize;					//!< ASIOobt@̃oCg.
static BYTE*			WavBuf[2];					//!< WAVt@Cobt@𕡐ubNɕ|C^e[u.
static DWORD			WavSize[2];					//!< WAVt@Cobt@̕ubNɓǂݍ񂾃f[^̃oCg.
static int				ActivePage;					//!< ASIOhCoĐĂ镪ubN̔ԍ.
static DWORD			ReadCnt;					//!< ASIOhCoĐĂ镪ubN̓ǂݍ݃JE^.


/****************************************************************************/
/*!
 *	@brief	AvP[VEC.
 *
 *	@param	[in]	hInst		݂̃CX^X̃nh.
 *	@param	[in]	hPreInst	ȑÕCX^X̃nh.
 *	@param	[in]	CmdLine		R}hC.
 *	@param	[in]	show		\.
 *
 *	@retval	0Ԃ.
 */
int WINAPI	WinMain( HINSTANCE hInst, HINSTANCE hPreInst, LPSTR CmdLine, int show )
{
	//! [Jϐ.
	AppWnd   = NULL;
	DataBuff = NULL;
	DataSize = 0;
	DevCnt   = 0;
	memset( DevName , 0, sizeof(DevName)  );
	memset( FileName, 0, sizeof(FileName) );

	//! RRg[.
    INITCOMMONCONTROLSEX ic;
	ic.dwSize = sizeof(INITCOMMONCONTROLSEX);
	ic.dwICC  = ICC_COOL_CLASSES;
	InitCommonControlsEx( &ic );

	//! _CAOI[v.
	DialogBox( hInst, MAKEINTRESOURCE(IDD_DIALOG_MAIN), NULL, (DLGPROC)SoundOutProc );

	return 0;
}

/****************************************************************************/
/*!
 *	@brief	_CAÕbZ[WEnh.
 *
 *	@param	[in]	hDlg	_CAO{bNX̃nh.
 *	@param	[in]	msg		bZ[W.
 *	@param	[in]	wParam	ŏ̃bZ[Wp[^.
 *	@param	[in]	lParam	2Ԗڂ̃bZ[Wp[^.
 *
 *	@retval	TRUE  = bZ[W.
 *	@retval	FALSE = bZ[WȂ.
 */
static LRESULT CALLBACK		SoundOutProc( HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam )
{
	switch( msg ){
	case WM_INITDIALOG:
		OnInitDialog( hDlg );
		break;

	case WM_COMMAND:
		switch( LOWORD(wParam) ){
		case IDC_FILE_SELECT:
			OnSelectFile( hDlg );
			break;

		case IDC_PLAY:
			PlaySoundOutput( hDlg );
			break;

		case IDC_PAUSE:
			PauseSoundOutput( hDlg );
			break;

		case IDC_STOP:
			StopSoundOutput( hDlg );
			break;

		case IDCANCEL:
			StopSoundOutput( hDlg );
			EndDialog( hDlg, 0 );
			break;

		default:
			return FALSE;
		}
		break;

	case WM_USER:
		WavSize[wParam] = ReadWaveFile( WavBuf[wParam], DataSize >> 1 );
		break;

	default:
		break;
	}
	return FALSE;
}

/****************************************************************************/
/*!
 *	@brief	_CAȌ.
 *
 *	@param	[in]	hDlg	_CAÕEChEEnh.
 *
 *	@retval	Ȃ.
 */
static void		OnInitDialog( HWND hDlg )
{
	//! ASIOhCõIuWFNg쐬.
	if( !asioDrivers ){
		asioDrivers = new AsioDrivers();
	}
	//! foCXi[z쐬.
	char* dev_list[10];
	for( DWORD i = 0; i < 10; i++ ){
		dev_list[i] = DevName[i];
	}
	//! ASIOfoCXXg擾.
	DevCnt = asioDrivers->getDriverNames( dev_list, 10 );

	//! ASIOfoCXXg쐬.
	HWND hItem = GetDlgItem( hDlg, IDC_OUTPUT_DEVICE );

	ComboBox_ResetContent( hItem );

	for( DWORD i = 0; i < DevCnt; i++ ){
		ComboBox_AddString( hItem, DevName[i] );
	}
	ComboBox_SetCurSel( hItem, 0 );
}

/****************************************************************************/
/*!
 *	@brief	ĐWAVt@CI.
 *
 *	@param	[in]	hDlg	_CAÕEChEEnh.
 *
 *	@retval	Ȃ.
 */
static BOOL		OnSelectFile( HWND hDlg )
{
	//! TEho͂t@Ct@CI_CAOI.
	OPENFILENAME ofn;
	memset( &ofn     , 0, sizeof(ofn)      );
	memset( &FileName, 0, sizeof(FileName) );
	ofn.lStructSize    = sizeof(ofn);
	ofn.hwndOwner      = hDlg;
	ofn.lpstrFilter    = _T("WAVEt@C(*.wav)\0*.wav\0SẴt@C(*.*)\0*.*\0\0");
	ofn.lpstrFile      = FileName;
	ofn.nMaxFile       = MAX_PATH;
	ofn.Flags          = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
	ofn.lpstrDefExt    = NULL;
	ofn.lpstrTitle     = _T("Đt@C");
	if( GetOpenFileName( &ofn ) ){
		SetWindowText( GetDlgItem( hDlg, IDC_FILENAME ), FileName );
		return TRUE;
	}
	return FALSE;
}

/****************************************************************************/
/*!
 *	@brief	WAVt@CĐ.
 *
 *	@param	[in]	hDlg	_CAÕEChEEnh.
 *
 *	@retval	TRUE = OK. / FALSE = NG.
 */
static BOOL		PlaySoundOutput( HWND hDlg )
{
	//! WAVt@CI[vĂȂꍇAI[v.
	if( !IsOpenWaveFile() ){

		//! -1._CAOĐWAVt@C擾.
		GetWindowText( GetDlgItem( hDlg, IDC_FILENAME ), FileName, sizeof(FileName) - 1 );

		//! -2.ĐWAVt@CI[v.
		if( !ReadOpenWaveFile( FileName ) ){
			MessageBox( hDlg, _T("t@CI[vł܂"), _T("WAVt@C̍Đ"), MB_OK );
			return FALSE;
		}
	}
	if( !AppWnd ){
		//! I[vWAVt@C̃I[fBIEtB[}bg擾.
		WAVEFORMATEX wf;
		GetAudioFormat( &wf );

		//! TEho̓foCXI[v.
		UINT num = ComboBox_GetCurSel( GetDlgItem( hDlg, IDC_OUTPUT_DEVICE ) );
		if( OpenSoundOutDevice( hDlg, num, &wf ) ){
			//! WAVt@C̓ǂݍݗpobt@mۂ.
			if( !DataBuff ){
				DataSize = BufSize * sizeof(WORD) * 32;
				DataBuff = new BYTE[DataSize];
			}
			//! WAVEt@Cǂݍ.
			WavBuf[0]  = DataBuff;
			WavBuf[1]  = &DataBuff[DataSize >> 1];
			WavSize[0] = ReadWaveFile( WavBuf[0], DataSize >> 1 );
			WavSize[1] = ReadWaveFile( WavBuf[1], DataSize >> 1 );
			ActivePage = 0;
			ReadCnt    = 0;
		}
		AppWnd = hDlg;
	}
	//! TEho͂Jn.
	ASIOStart();

	EnableWindow( GetDlgItem( hDlg, IDC_PLAY          ), FALSE );
	EnableWindow( GetDlgItem( hDlg, IDC_PAUSE         ), TRUE  );
	EnableWindow( GetDlgItem( hDlg, IDC_STOP          ), TRUE  );
	EnableWindow( GetDlgItem( hDlg, IDC_FILENAME      ), FALSE );
	EnableWindow( GetDlgItem( hDlg, IDC_FILE_SELECT   ), FALSE );
	EnableWindow( GetDlgItem( hDlg, IDC_OUTPUT_DEVICE ), FALSE );
	return TRUE;
}

/****************************************************************************/
/*!
 *	@brief	WAVt@C̍Đꎞ~.
 *
 *	@param	[in]	hDlg	_CAÕEChEEnh.
 *
 *	@retval	Ȃ.
 */
static void		PauseSoundOutput( HWND hDlg )
{
	//! I[fBIo͂~.
	ASIOStop();

	EnableWindow( GetDlgItem( hDlg, IDC_PLAY          ), TRUE  );
	EnableWindow( GetDlgItem( hDlg, IDC_PAUSE         ), FALSE );
	EnableWindow( GetDlgItem( hDlg, IDC_STOP          ), FALSE );
	EnableWindow( GetDlgItem( hDlg, IDC_FILENAME      ), TRUE  );
	EnableWindow( GetDlgItem( hDlg, IDC_FILE_SELECT   ), TRUE  );
	EnableWindow( GetDlgItem( hDlg, IDC_OUTPUT_DEVICE ), TRUE  );
}

/****************************************************************************/
/*!
 *	@brief	WAVt@C̍Đ~.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
static void		StopSoundOutput( HWND hDlg )
{
	//! TEho̓foCXN[Y.
	CloseSoundOutputDevice();

	//! ĐWAVt@CN[Y.
	CloseWaveFile();

	//! WAVt@C̓ǂݍݗpobt@.
	if( DataBuff ){
		delete [] DataBuff;
		DataBuff = NULL;
	}
	AppWnd = NULL;
	EnableWindow( GetDlgItem( hDlg, IDC_PLAY          ), TRUE  );
	EnableWindow( GetDlgItem( hDlg, IDC_PAUSE         ), FALSE );
	EnableWindow( GetDlgItem( hDlg, IDC_STOP          ), FALSE );
	EnableWindow( GetDlgItem( hDlg, IDC_FILENAME      ), TRUE  );
	EnableWindow( GetDlgItem( hDlg, IDC_FILE_SELECT   ), TRUE  );
	EnableWindow( GetDlgItem( hDlg, IDC_OUTPUT_DEVICE ), TRUE  );
}

/****************************************************************************/
/*!
 *	@brief	ASIOhCoI[v.
 *
 *	@param	[in]	hDlg	_CAÕEChEEnh.
 *	@param	[in]	num		I[vfoCXԍ.
 *	@param	[in]	wf		ĐWAVt@C̃I[fBI\̂̃|C^.
 *
 *	@retval	Ȃ.
 */
static BOOL		OpenSoundOutDevice( HWND hDlg, UINT num, WAVEFORMATEX* wf )
{
	if( num >= DevCnt ){
		return FALSE;
	}
	//! I[vhCo[h.
	asioDrivers->loadDriver( DevName[num] );

	do {
		//! ASIOfoCXI[v.
		ASIODriverInfo info;
		memset( &info, 0, sizeof(info) );
		info.asioVersion = 0;
		info.sysRef      = hDlg;
		if( ASIOInit( &info ) != ASE_OK ){
			break;
		}
		//! 쐬\ȃobt@TCY擾.
		long minimum;
		long maximum;
		long preferred;
		long granularity;
		if( ASIOGetBufferSize( &minimum, &maximum, &preferred, &granularity ) != ASE_OK ){
			break;
		}
		//! obt@i[̈.
		long i = 0;
		memset( BufInfo, 0, sizeof(BufInfo) );
		for( ; i < 2; i++ ){
			BufInfo[i].isInput    = ASIOFalse;
			BufInfo[i].channelNum = i;
		}
		BufSize = preferred;

		//! gp`l̃f[^obt@mۂ.
		static ASIOCallbacks cb;
		cb.bufferSwitch         = &bufferSwitch;
		cb.sampleRateDidChange  = NULL;
		cb.asioMessage          = NULL;
		cb.bufferSwitchTimeInfo = NULL;
		ASIOCreateBuffers( BufInfo, i, BufSize, &cb );

		//! Tv[gݒ肷.
		ASIOSetSampleRate( wf->nSamplesPerSec );
		return TRUE;

	}while( FALSE );

	CloseSoundOutputDevice();
	return FALSE;
}

/****************************************************************************/
/*!
 *	@brief	ASIOhCoN[Y.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
static void		CloseSoundOutputDevice( void )
{
	//! I[fBIo͂~.
	ASIOStop();

	//! o̓obt@.
	ASIODisposeBuffers();

	//! ASION[Y.
	ASIOExit();

	//! hCoA[h.
	if( asioDrivers ){
		asioDrivers->removeCurrentDriver();
	}
}

/****************************************************************************/
/*!
 *	@brief	f[^obt@̐؂ւʒm.
 *
 *	@param	[in]	index		obt@ԍ.
 *	@param	[in]	processNow	ASIOTrue = ɏ\.
 *
 *	@retval	Ȃ.
 */
static void		bufferSwitch( long index, ASIOBool processNow )
{
	if( WavSize[0] > 0 || WavSize[1] > 0 ){
		if( ReadCnt >= WavSize[ActivePage] ){
			PostMessage( AppWnd, WM_USER, ActivePage, 0 );

			ActivePage = (ActivePage + 1) & 1;
			ReadCnt    = 0;
		}
	}
	BYTE*	buf_l = (BYTE*)(BufInfo[0].buffers[index]);
	BYTE*	buf_r = (BYTE*)(BufInfo[1].buffers[index]);

	//! `l擾.
	ASIOChannelInfo info;
	info.channel = BufInfo[0].channelNum;
	info.isInput = BufInfo[0].isInput;
	ASIOGetChannelInfo( &info );

	switch( info.type ){
	case ASIOSTInt16LSB:
		//! 16rbgI[fBȈꍇ.
		memset( buf_l, 0, BufSize * 2 );
		memset( buf_r, 0, BufSize * 2 );
		if( WavSize[ActivePage] > 0 ){
			short*	dst_l = (short*)buf_l;
			short*	dst_r = (short*)buf_r;
			short*	src   = (short*)&(WavBuf[ActivePage][ReadCnt]);
			DWORD	limit = (WavSize[ActivePage] - ReadCnt) / 4;
			if( limit > BufSize ){
				limit = BufSize;
			}
			for( DWORD i = 0; i < limit; i++ ){
				*(dst_l++) = *(src++);
				*(dst_r++) = *(src++);
			}
			ReadCnt += (BufSize * 4);
		}
		break;

	case ASIOSTInt24LSB:
		//! 24rbgI[fBȈꍇ.
		memset( buf_l, 0, BufSize * 3 );
		memset( buf_r, 0, BufSize * 3 );
		if( WavSize[ActivePage] > 0 ){
			BYTE*	dst_l = buf_l;
			BYTE*	dst_r = buf_r;
			BYTE*	src   = &(WavBuf[ActivePage][ReadCnt]);
			DWORD	limit = (WavSize[ActivePage] - ReadCnt) / 4;
			if( limit > BufSize ){
				limit = BufSize;
			}
			for( DWORD i = 0; i < limit; i++ ){
				*(dst_l++) = 0x00;
				*(dst_l++) = *(src++);
				*(dst_l++) = *(src++);

				*(dst_r++) = 0x00;
				*(dst_r++) = *(src++);
				*(dst_r++) = *(src++);
			}
			ReadCnt += (BufSize * 4);
		}
		break;

	case ASIOSTInt32LSB:
		//! 32rbgI[fBȈꍇ.
		memset( buf_l, 0, BufSize * 4 );
		memset( buf_r, 0, BufSize * 4 );
		if( WavSize[ActivePage] > 0 ){
			short*	dst_l = (short*)buf_l;
			short*	dst_r = (short*)buf_r;
			short*	src   = (short*)&(WavBuf[ActivePage][ReadCnt]);
			DWORD	limit = (WavSize[ActivePage] - ReadCnt) / 4;
			if( limit > BufSize ){
				limit = BufSize;
			}
			for( DWORD i = 0; i < limit; i++ ){
				*(dst_l++) = 0;
				*(dst_l++) = *(src++);
				*(dst_r++) = 0;
				*(dst_r++) = *(src++);
			}
			ReadCnt += (BufSize * 4);
		}
		break;

	case ASIOSTInt32LSB16:
	case ASIOSTInt32LSB18:
	case ASIOSTInt32LSB20:
	case ASIOSTInt32LSB24:
	case ASIOSTFloat32LSB:
	case ASIOSTInt32MSB:
	case ASIOSTInt32MSB16:
	case ASIOSTInt32MSB18:
	case ASIOSTInt32MSB20:
	case ASIOSTInt32MSB24:
	case ASIOSTFloat32MSB:
		memset( buf_l, 0, BufSize * 4 );
		memset( buf_r, 0, BufSize * 4 );
		break;

	case ASIOSTFloat64LSB:
	case ASIOSTFloat64MSB: 
		memset( buf_l, 0, BufSize * 8 );
		memset( buf_r, 0, BufSize * 8 );
		break;

	case ASIOSTInt16MSB:
		memset( buf_l, 0, BufSize * 2 );
		memset( buf_r, 0, BufSize * 2 );
		break;

	case ASIOSTInt24MSB:
		memset( buf_l, 0, BufSize * 3 );
		memset( buf_r, 0, BufSize * 3 );
		break;
	}
	// ASIOOutputReady()T|[gĂꍇAASIOOutputReady()Ăяo.
	ASIOOutputReady();
}

/* End of file */
